#include <stdio.h>
#include <stdlib.h>

const int SIZE = 64;

// Moyenne des pixels de l'image <im>
double moyenne(int n,int im[n][n]) {
   double size = n*n;
   double moy = 0.0;
   for (int i=0;i<n;i++) {
      for (int j=0;j<n;j++) {
         moy += im[i][j]/size;
      }
   }
   return moy;
}

// Nombre de pixels de l'image <im> dont la différence
// à la valeur <val> est supérieure à une tolérance <tol>
int nb_pixels_diff(int n,int im[n][n],double val,double tol) {
   // à compléter
   return 0;
}

// Affectation de la valeur <val> à tous les pixels de l’image <im>
void copy(int n,int im[n][n],int val) {
   // à compléter
}

void copy_slice(int decal_x,int decal_y,int n,int im1[n][n],int k,int im2[k][k]) {
   // à compléter
}

void copy_back(int decal_x,int decal_y,int n,int im1[n][n],int k,int im2[k][k]) {
   // à compléter
}

//Lissage récursif de l'image <im> en remplaçant les pixels
// d'un quadrant par leur moyenne 
void lissage(int n,int im[n][n],double tol,double seuil) {
   double moy = moyenne(n,im);
   double size = n*n;
   if (nb_pixels_diff(n,im,moy,tol)/size < seuil) {
      copy(n,im,moy);
   } else { // si on ne peut pas lisser l'image, alors on essaie sur les quadrants
      int quadrant[n/2][n/2];
      copy_slice(0,0,n,im,n/2,quadrant);
      lissage(n/2,quadrant,tol,seuil);
      copy_back(0,0,n,im,n/2,quadrant);
      copy_slice(n/2,0,n,im,n/2,quadrant);
      lissage(n,quadrant,tol,seuil);
      copy_back(n/2,0,n,im,n/2,quadrant);
      copy_slice(0,n/2,n,im,n/2,quadrant);
      lissage(n/2,quadrant,tol,seuil);
      copy_back(0,n/2,n,im,n/2,quadrant);
      copy_slice(n/2,n/2,n,im,n/2,quadrant);
      lissage(n,quadrant,tol,seuil);
      copy_back(n/2,n/2,n,im,n/2,quadrant);
   }
}

void main() {
   int image_gris[SIZE][SIZE];
   copy(SIZE,image_gris,234);
   lissage(SIZE,image_gris,0.1,10.0);
}
